/* A0Event.h
 *
 *
 * 19970128 BS creation
 */

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

#import "../General.bproj/Protocols.h"


@interface A0Event : NSObject//NSMutableDictionary
                     <PajeEvent, NSCoding>
{
    id name;
    id node;
    id thread;
    id time;
    NSMutableDictionary *fieldDict;
}

+ (void)initialize;

+ (NSString *)name;
+ (NSArray *)allNames;
+ (id)entityType;
+ (NSMutableDictionary *)defaultColorDict;
+ (NSMutableDictionary *)colorDict;
+ (void)setColorDict:(id)dict;
+ (NSColor *)colorForName:(NSString *)name;
+ (void)setColor:(NSColor *)color forName:(NSString *)name;

+ (id)eventWithObjects:(NSArray *)objects forKeys:(NSArray *)keys;
- (id)initWithObjects:(NSArray *)objects forKeys:(NSArray *)keys;

- (id)objectForKey:(id)aKey;
- (NSEnumerator *)keyEnumerator;
- (NSArray *)allKeys;
- (void)setObject:(id)anObject forKey:(id)aKey;
- (void)removeObjectForKey:(id)theKey;

- (NSArray *)fieldNames;
- (id)valueOfFieldNamed:(NSString *)fieldName;

- (id)serialNo;
- (void)setColor:(NSColor *)c;
- (NSArray *)relatedEntities;

//
// PajeEvent protocol
//
- (NSColor *)color;
- (void)setColor:(NSColor *)c;
- (void)takeColorFrom:sender;
- (void)inspect;
- (void)inspect:(id)sender;
- (id)entityType;
- (id)name;
- (id)node;
- (id)thread;
- (NSDate *)time;
- (id)service;
- (NSDate *)startTime;
- (NSDate *)endTime;
- (NSDate *)firstTime;
- (NSDate *)lastTime;
- (id)duration;
- (id)serialNo;
- (NSArray *)relatedEntities;

- (void)setName:(id)o;
- (void)setNode:(id)o;
- (void)setThread:(id)o;
- (void)setTime:(id)o;

- (void)setRelatedEntities:(NSArray *)relatedEntities;
- (void)setRelatedEntity:(id)entity;
- (void)addRelatedEntity:(id)entity;
- (void)removeRelatedEntity:(id)entity;

// NSCoding Protocol
- (void)encodeWithCoder:(NSCoder *)coder;
- (id)initWithCoder:(NSCoder *)coder;
@end
