#import <stdio.h>
#import <Foundation/Foundation.h>
#import <Foundation/NSFileHandle.h>
#import "A0Event.h"
#import "../General.bproj/PTime.h"
#import "DataScanner.h"
#import "../General.bproj/PajeFilter.h"

//typedef enum {
//	INT_VALUE, HEX_VALUE, DOUBLE_VALUE, STRING_VALUE
//} field_type_t;

@interface A0bReader: PajeComponent
{
        NSFileHandle *inputFile;
        NSString *remainsOfLastRead;
	NSString *inputFilename;
	int inputLineNumber;
        unsigned long long bytesScanned;
        
	NSMutableDictionary *eventNames;
	NSMutableDictionary *eventFieldTypes;
	NSMutableDictionary *eventFieldNames;
        
        NSDate *currentTime;
        DataScanner *scanner;
        NSCharacterSet *percent;
        NSCharacterSet *delimiter;
        NSMutableCharacterSet *alphanum;
}

- (id)init;
- (void)readTraceFile:(NSString *)fileName;
- (NSDictionary *)setInputFilename:(NSString *)filename;
- (BOOL)readNextLine;
- (BOOL)readNextEventDefinition;
- (BOOL)readNextEvent;
- (A0Event *)readEvent;
- (void)reset;
- (void)setCurrentTime:(NSDate *)time;
- (NSDate *)currentTime;
- (void)raise:(NSString *)reason;

- (void)encodeCheckPointWithCoder:(NSCoder *)coder;
- (void)decodeCheckPointWithCoder:(NSCoder *)coder;
@end
