/* A0bThreadId.h created by benhur on 9 Dec 1997 */

#import <AppKit/AppKit.h>

/*
 * A0bThreadId
 * Object that identifies uniquely a thread in the system.
 */

@interface A0bThreadId : NSObject<NSCopying,NSCoding>
{
    id node;
    id thread;
}

//
// creation, initialization and destruction
//
+ (A0bThreadId *)threadIdWithNode:(id)n thread:(id)t;
- (id)initWithNode:(id)n thread:(id)t;
- (void)dealloc;

//
// getting info from it
//
- (id)node;
- (id)thread;
// hack, needed for displaying without filtering (should provide a better
// interface for this).
- (int)intValue;

//
// reimplementing some of NSObject protocol, for comparisions
//
- (unsigned int)hash;
- (BOOL)isEqual:(id)other;
//  and printing
- (NSString *)description;

// NSCopying protocol
- (id)copyWithZone:(NSZone *)zone;

// NSCoding Protocol
- (void)encodeWithCoder:(NSCoder *)coder;
- (id)initWithCoder:(NSCoder *)coder;
@end
