/* A0bThread.m created by benhur on 9 Dec 1997 */

#import "A0bThreadId.h"

@implementation A0bThreadId
//
// creation, initialization and destruction
//
+ (A0bThreadId *)threadIdWithNode:(id)n thread:(id)t
{
    return [[[self alloc] initWithNode:n thread:t] autorelease];
}

- (id)initWithNode:(id)n thread:(id)t
{
    [super init];
    node = [n retain];
    thread = [t retain];
    return self;
}

- (void)dealloc;
{
    [node release];
    [thread release];
    [super dealloc];
}

//
// getting info from it
//
- (id)node   { return node; }
- (id)thread { return thread; }

// hack, needed for displaying without filtering (should provide a better
// interface for this).
- (int)intValue { return [thread intValue]; }

//
// reimplementing some of NSObject protocol, for comparisions
//
- (unsigned int)hash
{
    return ([node intValue] << 4) ^ [thread intValue];
}

- (BOOL)isEqual:(id)other
{
    return (self == other
            || ([other isKindOfClass:[self class]]
                && ([node isEqual:[other node]]
                    && [thread isEqual:[other thread]]))
            || [other isEqual:self]);
}

- (NSString *)description
{
    return [NSString stringWithFormat:@"(%@, %@)", node, thread];
}

// NSCopying protocol
- (id)copyWithZone:(NSZone *)zone
{
    // a threadId is immutable
    return [self retain];
}

// NSCoding Protocol
- (void)encodeWithCoder:(NSCoder *)coder
{
//    [super encodeWithCoder:coder];
    [coder encodeObject:node];
    [coder encodeObject:thread];
}

- (id)initWithCoder:(NSCoder *)coder
{
    self = [super init];//WithCoder:coder];
    node = [[coder decodeObject] retain];
    thread = [[coder decodeObject] retain];
    return self;
}
@end
