//
// A0Comm
// ------
//
// entity that represents a communication between two threads
//

#import "A0Link.h"
#import "../A0bReader.bproj/A0Event.h"

@interface A0Comm : A0Link
{
    A0Event *sendEvent;
    A0Event *sendCompletionEvent;
    A0Event *recvEvent;
    A0Event *recvCompletionEvent;
}
+ (A0Comm *)asynchronousCommunication;
+ (A0Comm *)synchronousCommunication;
+ (A0Comm *)communication;
- (id)initWithName:(NSString *)n;
- (void)setSendEvent:(A0Event *)e;
- (void)setSendCompletionEvent:(A0Event *)e;
- (void)setRecvEvent:(A0Event *)e;
- (void)setRecvCompletionEvent:(A0Event *)e;

- (id)port;
- (id)tag;
- (id)size;
- (id)sourceNode;
- (id)destNode;
- (id)sourceNodeId;
- (id)destNodeId;
@end
