//
// A0Link
// ------
//
// entities that represent a link, 
// a causal relationship between two other entities
//

#import "A0Entity.h"
#import "../A0bReader.bproj/A0Event.h"
#import "A0State.h"

@interface A0Link : A0Entity <PajeLink>
+ (A0Link *)newMutexLinkFromEvent:(id <PajeEvent>)e
                          toState:(id <PajeState>)s;
+ (A0Link *)unlockMutexLinkFromEvent:(id <PajeEvent>)e1
                             toEvent:(id <PajeEvent>)e2;
+ (A0Link *)newSemaphoreLinkFromEvent:(id <PajeEvent>)e
                              toState:(id <PajeState>)s;
+ (A0Link *)VSemaphoreLinkFromEvent:(id <PajeEvent>)e1
                            toEvent:(id <PajeEvent>)e2;
+ (A0Link *)newSlaveLinkFromEvent:(id <PajeEvent>)e
                          toState:(id <PajeState>)s;
+ (A0Link *)joinLinkFromEvent:(id <PajeEvent>)e
                      toState:(id <PajeState>)s;
+ (A0Link *)newPipeLinkFromEvent:(id <PajeEvent>)e
                         toState:(id <PajeState>)s;
+ (A0Link *)startRemoteThreadLinkFromEvent:(id <PajeEvent>)e1
                                   toEvent:(id <PajeEvent>)e2;
+ (A0Link *)startRemoteUrgentLinkFromEvent:(id <PajeEvent>)e1
                                   toEvent:(id <PajeEvent>)e2;

- (id)sourceNode;
- (id)sourceThread;
- (id)sourceService;
- (id)destNode;
- (id)destThread;
- (id)destService;
@end
