#import "A0LinkInspector.h"
#import "A0Link.h"
#import "A0Comm.h"

@implementation A0LinkInspector
- (void)addLocalFields
{
    NSBox *box;
    A0Link *inspectedLink = inspectedEntity;

    // source thread id
    box = [self boxWithTitle:@"Source Identification"
                 fieldTitles:[NSArray arrayWithObjects:@"Node", @"Thread", @"Service", nil]
                 fieldValues:[NSArray arrayWithObjects:[inspectedLink sourceNode], [inspectedLink sourceThread], [inspectedLink sourceService], nil]];
    [self addSubview:box atBottom:NO];

    // dest thread id
    box = [self boxWithTitle:@"Destination Identification"
                 fieldTitles:[NSArray arrayWithObjects:@"Node", @"Thread", @"Service", nil]
                 fieldValues:[NSArray arrayWithObjects:[inspectedLink destNode], [inspectedLink destThread], [inspectedLink destService], nil]];
    [self addSubview:box atBottom:NO];

    // timing
    box = [self boxWithTitle:@"Timing"
                 fieldTitles:[NSArray arrayWithObjects:@"Start", @"End", @"Duration", nil]
                 fieldValues:[NSArray arrayWithObjects:[inspectedLink startTime], [inspectedLink endTime], [inspectedLink duration], nil]];
    [self addSubview:box atBottom:NO];
    
    // size (A0Comm)
    if ([inspectedLink respondsToSelector:@selector(size)]) {
        int size = [[(A0Comm *)inspectedLink size] intValue];
        double duration = [[inspectedLink lastTime] timeIntervalSinceDate:[inspectedLink firstTime]];
        if (duration > 0) {
            box = [self boxWithTitle:@"Size"
                         fieldTitles:[NSArray arrayWithObjects:@"Size", @"Throughput", nil]
                         fieldValues:[NSArray arrayWithObjects:[NSString stringWithFormat:@"%d", size], [NSString stringWithFormat:@"%.2f kb/s", size/duration/1000], nil]];
        } else {
            box = [self boxWithTitle:@"Size"
                         fieldTitles:[NSArray arrayWithObject:@"Size"]
                         fieldValues:[NSArray arrayWithObject:[NSString stringWithFormat:@"%d", size]]];
        }
        [self addSubview:box atBottom:NO];
    }
}
@end
