
#import "A0Entity.h"
#import "../A0bReader.bproj/A0Event.h"

@class A0bSemaphore, A0bMutex;

@interface A0State : A0Entity <PajeState>
@end

@interface A0TwoEventsState : A0State
{
    A0Event *firstEvent;
    A0Event *secondEvent;
}
- (id)initWithStartEvent:(A0Event *)e;
- (void)setEndEvent:(A0Event *)e;
- (A0Event *)startEvent;
- (A0Event *)endEvent;
- (id)thread;
@end

@interface A0ThreadState : A0TwoEventsState
+ (A0ThreadState *)runnableThreadStateFromEvent:(A0Event *)e;
+ (A0ThreadState *)blockedThreadStateFromEvent:(A0Event *)e;
@end

@interface A0SemaphoreState : A0TwoEventsState
{
    A0bSemaphore *semaphore;
    int value;
}
+ (A0SemaphoreState *)blockedSemaphoreStateFromEvent:(A0Event *)e
                                           semaphore:(A0bSemaphore *)sema
                                               value:(int)v;
+ (A0SemaphoreState *)unblockedSemaphoreStateFromEvent:(A0Event *)e
                                             semaphore:(A0bSemaphore *)sema
                                                 value:(int)v;
@end

@interface A0MutexState : A0TwoEventsState
{
    A0bMutex *mutex;
}
+ (A0MutexState *)lockedMutexStateFromEvent:(A0Event *)e
                                      mutex:(A0bMutex *)m;
+ (A0MutexState *)unlockedMutexStateFromEvent:(A0Event *)e
                                        mutex:(A0bMutex *)m;
- (A0bMutex *)mutex;
@end

@interface A0MutexThreadState : A0TwoEventsState
{
    A0bMutex *mutex;
}
+ (A0MutexThreadState *)waitingMutexThreadStateFromEvent:(A0Event *)e
                                                   mutex:(A0bMutex *)m;
+ (A0MutexThreadState *)holdingMutexThreadStateFromEvent:(A0Event *)e
                                                   mutex:(A0bMutex *)m;
@end
