#import "../A0bReader.bproj/A0EventInspector.h"
#import "A0State.h"

@interface A0StateInspector : A0EventInspector
- (void)addLocalFields;
@end

@implementation A0StateInspector
- (void)addLocalFields
{
    NSBox *box;

    // timing
    if ([[inspectedEntity endTime] isEqual:[NSDate distantFuture]])
        box = [self boxWithTitle:@"Timing"
                     fieldTitles:[NSArray arrayWithObjects:@"Start", @"End", nil]
                     fieldValues:[NSArray arrayWithObjects:[inspectedEntity startTime], @"Unknown", nil]];
    else
        box = [self boxWithTitle:@"Timing"
                     fieldTitles:[NSArray arrayWithObjects:@"Start", @"End", @"Duration", nil]
                     fieldValues:[NSArray arrayWithObjects:[inspectedEntity startTime], [inspectedEntity endTime], [inspectedEntity duration], nil]];
    [self addSubview:box atBottom:NO];
}
@end

@interface A0ThreadStateInspector : A0StateInspector
@end
@implementation A0ThreadStateInspector
- (void)addLocalFields
{
    NSBox *box;

    // thread id
    box = [self boxWithTitle:@"Thread Identification"
                 fieldTitles:[NSArray arrayWithObjects:@"Node", @"Thread", @"Service", nil]
                  fieldValues:[NSArray arrayWithObjects:[inspectedEntity node], [inspectedEntity thread], [inspectedEntity service], nil]];
    [self addSubview:box atBottom:NO];
    [super addLocalFields];
}
@end


@interface A0MutexStateInspector : A0StateInspector
@end
@implementation A0MutexStateInspector
- (void)addLocalFields
{
    NSBox *box;

    // mutex id
    box = [self boxWithTitle:@"Mutex Identification"
                 fieldTitles:[NSArray arrayWithObjects:@"Node", @"Mutex", nil]
                 fieldValues:[NSArray arrayWithObjects:[inspectedEntity node], [(A0MutexState *)inspectedEntity mutex], nil]];
    [self addSubview:box atBottom:NO];
    [super addLocalFields];
}
@end


@interface A0SemaphoreStateInspector : A0StateInspector
@end
@implementation A0SemaphoreStateInspector
- (void)addLocalFields
{
    NSBox *box;

    // mutex id
    box = [self boxWithTitle:@"Semaphore Identification"
                 fieldTitles:[NSArray arrayWithObjects:@"Node", @"Semaphore", nil]
                 fieldValues:[NSArray arrayWithObjects:[inspectedEntity node], [inspectedEntity container], nil]];
    [self addSubview:box atBottom:NO];
    [super addLocalFields];
}
@end


@interface A0MutexThreadStateInspector : A0MutexStateInspector
@end
@implementation A0MutexThreadStateInspector
- (void)addLocalFields
{
    NSBox *box;
    
    // thread id
    box = [self boxWithTitle:@"Thread Identification"
                 fieldTitles:[NSArray arrayWithObjects:@"Node", @"Thread", @"Service", nil]
                 fieldValues:[NSArray arrayWithObjects:[inspectedEntity node], [inspectedEntity thread], [inspectedEntity service], nil]];
    [self addSubview:box atBottom:NO];
    [super addLocalFields];
}
@end
