/* A0bComm.h
 *
 * Represents communications in Athapascan 0
 *
 * 19970219 BS creation
 * 19970303 BS redefinition as subclass of A0bState
 */

#import "A0bState.h"

// Possible types of communications
extern NSString *PCommNewSlave;
extern NSString *PCommNewPipe;
extern NSString *PCommJoin;
extern NSString *PCommStartRemoteThread;
extern NSString *PCommStartRemoteUrgent;
extern NSString *PCommMessage;


@interface A0bComm : A0bState <PajeComm>
{
}
+ (A0bComm *)commWithName:(NSString *)name;
+ (A0bComm *)linkWithName:(NSString *)string
               fromEntity:(id<PajeEntity>)fromEntity
                 toEntity:(id<PajeEntity>)toEntity;
- (id)initWithName:(NSString *)name;

- (void)setSourceNode:(id)o;
- (void)setSourceThread:(id)o;
- (void)setSourceService:(id)o;
- (void)setDestNode:(id)o;
- (void)setDestThread:(id)o;
- (void)setDestService:(id)o;

@end