/* A0bGlobalId.m created by benhur on 27.apr.1998 */

#import "A0bGlobalId.h"

@implementation xA0bGlobalId
+ (xA0bGlobalId *)globalIdWithNodeId:(id)node localId:(id)local
{
    return [[[self alloc] initWithNodeId:node localId:local] autorelease];
}

- (id)initWithNodeId:(id)node localId:(id)local
{
    [super init];
    localId = [local retain];
    nodeId = [node retain];
    return self;
}

- (void)dealloc
{
    [localId release];
    [nodeId release];
    [super dealloc];
}

- (id)localId
{
    return localId;
}

- (id)nodeId
{
    return nodeId;
}

- (int)xintValue
{
    return [localId intValue];
}

// from NSObject protocol
- (unsigned int)hash
{
    return [localId intValue] | [nodeId intValue];
}

- (BOOL)isEqual:(id)obj
{
    return ((obj == self)
            || ([obj respondsToSelector:@selector(localId)]
                && [localId isEqual:[obj localId]]
                && [obj respondsToSelector:@selector(nodeId)]
                && [nodeId isEqual:[obj nodeId]]));
}

- (NSComparisonResult)compare:(id)other
{
    NSComparisonResult result;
    if ([self isMemberOfClass:[xA0bGlobalId class]]
        || ([self class] == [other class])) {
        result = [(NSNumber *)nodeId compare:[other nodeId]];
        if (result != NSOrderedSame)
            return result;
        return [(NSNumber *)localId compare:[other localId]];
    } else {
        if ([other isMemberOfClass:[xA0bGlobalId class]])
            return [(xA0bGlobalId *)other compare:self];
        if (![other respondsToSelector:@selector(nodeId)])
            return NSOrderedDescending;
        result = [(NSNumber *)nodeId compare:[other nodeId]];
        if (result != NSOrderedSame)
            return result;
        return [NSStringFromClass([self class]) compare:NSStringFromClass([other class])];
    }
}

- (NSString *)description
{
    return [NSString stringWithFormat:@"(%@,%@)", nodeId, localId];
}

// NSCopying protocol
- (id)copyWithZone:(NSZone *)zone
{
    return [self retain];
}

// NSCoding Protocol
- (void)encodeWithCoder:(NSCoder *)coder
{
//    [super encodeWithCoder:coder];
    [coder encodeObject:localId];
    [coder encodeObject:nodeId];
}

- (id)initWithCoder:(NSCoder *)coder
{
    self = [super init];//WithCoder:coder];
    localId = [[coder decodeObject] retain];
    nodeId = [[coder decodeObject] retain];
    return self;
}
@end

