/* A0bMutex.h created by benhur on 27.apr.1998 */

@class A0bMutex;

#import <Foundation/Foundation.h>
#import "A0bSimul.h"
#import "../A0bReader.bproj/A0Event.h"
#import "A0State.h"

@class A0bSimul;

@interface A0bMutex : PajeContainer
{
    A0bSimul *simulator;
    A0Event *lastEvent;
    A0MutexState *currentState;
    NSMutableDictionary *waitingStates;
    A0MutexThreadState *holdingState; // state when the mutex is being held
    A0Event *lockEvent;         // event that locked the mutex (when locked)
    A0Event *lastUnlockEvent;     // A0bUnlockMutex waiting for thread to unlock

    NSDate *creationTime;
    NSDate *destructionTime;
}

- (id)initWithId:(id)ident node:(A0bNode *)n;
- (void)dealloc;

+ (A0bMutex *)mutexWithId:(id)ident node:(A0bNode *)n;

+ (PajeContainerType *)entityType;

- (A0bNode *)node;

- (void)setSimulator:(A0bSimul *)simul;
- (void)setLastEvent:(A0Event *)event;
- (void)setLastUnlockEvent:(A0Event *)event;
- (void)unlockWithEvent:(A0Event *)event;

// Athapascan events
- (void)a0NewMutex:(A0Event *)event;
- (void)a0LockMutex:(A0Event *)event;
- (void)a0UnlockMutex:(A0Event *)event;
- (void)a0DisposeMutex:(A0Event *)event;
- (void)a0WaitCondition:(A0Event *)event;

// NSCoding Protocol
- (void)encodeWithCoder:(NSCoder *)coder;
- (id)initWithCoder:(NSCoder *)coder;
@end
