/* A0bNode.h
 *
 *
 * 19970128 BS creation
 */

#import <Foundation/Foundation.h>
#import "A0bThread.h"
#import "../General.bproj/PSortedArray.h"
#import "../General.bproj/PajeContainer.h"

@interface A0bNode : PajeContainer
{
    id nodeId;
    A0bSimul *simulator;
    NSMutableDictionary *threads;
    NSMutableDictionary *mutexes;
    NSMutableDictionary *semaphores;
    PSortedArray *pendingThreadCreations;
    PSortedArray *pendingSends;
    NSMutableDictionary *pendingSendCompletions;
    NSMutableArray *pendingSendComms;
    PSortedArray *pendingReceives;
    NSMutableDictionary *pendingReceiveCompletions;
    NSMutableArray *pendingReceiveComms;
    NSMutableDictionary *instances;

    NSMutableDictionary *userEntities; // current user states, mapped by entityType

    NSMutableDictionary *reallyPendingSends;
    NSMutableDictionary *reallyPendingReceives;
}


+ (A0bNode *)nodeWithId:(id)nId
              simulator:(A0bSimul *)simul
              container:(PajeContainer *)cont;
- (id)initWithId:(id)nId
       simulator:(A0bSimul *)simul
       container:(PajeContainer *)cont;

- (id)nodeId;

+ (PajeContainerType *)entityType;

- (void)addThread:(A0bThread *)thread;
- (A0bThread *)threadWithId:(id)threadId;
- (NSEnumerator *)threadsEnumerator;
- (void)removeThread:(A0bThread *)thread;

- (void)addMutex:(A0bMutex *)mutex;
- (A0bMutex *)mutexWithId:(id)mutexId;
- (NSEnumerator *)mutexesEnumerator;
- (void)removeMutex:(A0bMutex *)mutex;

- (void)addSemaphore:(A0bSemaphore *)semaphore;
- (A0bSemaphore *)semaphoreWithId:(id)semaphoreId;
- (NSEnumerator *)semaphoresEnumerator;
- (void)removeSemaphore:(A0bSemaphore *)semaphore;

- (PSortedArray *)pendingThreadCreations;
- (PSortedArray *)pendingSends;
- (NSMutableDictionary *)pendingSendCompletions;
- (NSMutableArray *)pendingSendComms;
- (PSortedArray *)pendingReceives;
- (NSMutableDictionary *)pendingReceiveCompletions;
- (NSMutableArray *)pendingReceiveComms;

- (NSMutableDictionary *)reallyPendingSends;
- (NSMutableDictionary *)reallyPendingReceives;

- (NSDate *)startTime;
- (NSDate *)endTime;

// NSObject protocol
- (unsigned int)hash;
- (BOOL)isEqual:(id)anObject;

// NSCoding Protocol
- (void)encodeWithCoder:(NSCoder *)coder;
- (id)initWithCoder:(NSCoder *)coder;
@end
