/* A0bSemaState.m created by benhur on Thu 22-May-1997 */

#import "A0bSemaState.h"

static NSMutableDictionary *colorDict;

// Define possible states' names
NSString *PSemaBlocked    = @"Sema Blocked";
NSString *PSemaUnblocked  = @"Sema Unblocked";
NSString *PSemaBlockable  = @"Sema Unblocked--will block";

@implementation A0bSemaState

+ (NSString *)name
{
    return @"Semaphore State";
}

+ (id)entityType
{
    return PajeSemaState;
}

+ (NSMutableDictionary *)defaultColorDict
{
    return [NSMutableDictionary dictionaryWithObjectsAndKeys:
        [NSColor colorWithCalibratedRed:0.2 green:0.6 blue:0.2 alpha:1.0],     PSemaUnblocked,
        [NSColor colorWithCalibratedRed:0.8 green:0.2 blue:0.2 alpha:1.0],     PSemaBlocked,
        [NSColor colorWithCalibratedRed:0.8 green:0.8 blue:0.2 alpha:1.0],     PSemaBlockable,
        nil];
}

+ (NSMutableDictionary *)colorDict
{
    return colorDict;
}

+ (void)setColorDict:(id)dict
{
    id tmp = [dict retain];
    [colorDict release];
    colorDict = tmp;
}

- (id)entityType
{
    return PajeSemaState;
}

- (void)setValue:(id)value
{
    [self setObject:value forKey:@"Value"];
}
- (void)setSemaphore:(id)semaId
{
    [self setObject:semaId forKey:@"Semaphore"];
}
- (void)setMutex:(id)mutexId
{
    [self setObject:mutexId forKey:@"Mutex"];
    [self setObject:mutexId forKey:@"Semaphore"];
}

- (id)node
{
    return [[self objectForKey:@"Semaphore"] nodeId];
}
- (id)thread
{
    return [[fieldDict objectForKey:@"Semaphore"] serialNo];
}
- (id)sourceThread
{
    return [self thread];
}
- (id)destThread
{
    return [self thread];
}

- (id)service
{
    return @"Sema";
}

- (id)container { return [NSArray arrayWithObjects:[self node], [self thread], nil]; }
+ (id)hierarchy {
    static id hier = nil;
    if (!hier)
        hier = [[NSArray alloc] initWithObjects:@"Node", @"Semaphore", nil];
    return hier;
}

@end
