/* A0bSemaphore.h created by benhur on Thu 22-May-1997 */

@class A0bSemaphore;

#import <Foundation/Foundation.h>
#import "A0bSimul.h"
#import "../A0bReader.bproj/A0Event.h"
#import "../General.bproj/PSortedArray.h"
#import "A0bGlobalId.h"

@class A0bSimul;

@interface A0bSemaphore : PajeContainer
{
    int value;
    A0bSimul *simulator;
    A0Event *lastEvent;
    A0SemaphoreState *currentState;
    NSMutableArray *blockedThreads;
    NSMutableArray *waitingVs;  // VSemaphore events that are waiting for a thread to unblock

    NSDate *creationTime;
    NSDate *destructionTime;
}

- (id)initWithId:(id)ident node:(A0bNode *)n;
- (void)dealloc;

+ (A0bSemaphore *)semaphoreWithId:(id)ident node:(A0bNode *)n;

+ (PajeContainerType *)entityType;

- (A0bNode *)node;

- (void)setSimulator:(A0bSimul *)simul;
- (void)setLastEvent:(A0Event *)event;

- (void)a0NewSemaphore:(A0Event *)event;
- (void)a0PSemaphore:(A0Event *)event;
- (void)a0VSemaphore:(A0Event *)event;
- (void)a0TryPSemaphore:(A0Event *)event;
- (void)a0DisposeSemaphore:(A0Event *)event;

// NSCoding Protocol
- (void)encodeWithCoder:(NSCoder *)coder;
- (id)initWithCoder:(NSCoder *)coder;
@end
