/* see A0bState.h */

#import "A0bState.h"
#import "A0bThread.h"

static NSMutableDictionary *colorDict;

// Define possible states' names
NSString *PThreadRunnable           = @"Runnable";
NSString *PThreadBlocked            = @"Blocked";
NSString *PThreadBlockedSend        = @"Blocked in send";
NSString *PThreadBlockedReceive     = @"Blocked in receive";
NSString *PThreadBlockedWaitRequest = @"Blocked in wait";
NSString *PThreadBlockedSema        = @"Blocked in semaphore";
NSString *PThreadBlockedMutex       = @"Blocked in mutex";
NSString *PThreadBlockedJoin        = @"Blocked in join";

@implementation A0bState

+ (NSMutableDictionary *)defaultColorDict
{
    return [NSMutableDictionary dictionaryWithObjectsAndKeys:
        [NSColor greenColor],	PThreadRunnable,
        [NSColor redColor],	PThreadBlocked,
        [NSColor redColor],	PThreadBlockedSend,
        [NSColor redColor],	PThreadBlockedReceive,
        [NSColor redColor],	PThreadBlockedWaitRequest,
        [NSColor redColor],	PThreadBlockedSema,
        [NSColor redColor],	PThreadBlockedMutex,
        [NSColor redColor],	PThreadBlockedJoin,
        nil];
}

+ (NSMutableDictionary *)colorDict
{
    return colorDict;
}

+ (void)setColorDict:(id)dict
{
    id tmp = [dict retain];
    [colorDict release];
    colorDict = tmp;
}

+ (NSArray *)allNames
{
    return [[self colorDict] allKeys];
}

+ (NSString *)name
{
    return @"Thread State";
}

+ (A0bState *)stateWithName:(NSString *)string
{
    return [[[self alloc] initWithName:string] autorelease];
}

- (id)XinitWithName:(NSString *)string
{
    [super init];
    fieldDict = [[NSMutableDictionary dictionaryWithObjectsAndKeys:
        string,                          @"Name",
//        [[self colorDict] objectForKey:string], @"Color",
        nil] retain];
    return self;
}

- (id)XinitWithObjects:(id*)objects
              forKeys:(id*)keys
                count:(unsigned int)count
{
    [super init];
    fieldDict = [[NSMutableDictionary dictionaryWithObjects:objects
                                                    forKeys:keys count:count]
        retain];
    return self;
}


- (NSDate *)time        {return [fieldDict objectForKey:@"StartTime"];}
- (NSDate *)startTime   {return [fieldDict objectForKey:@"StartTime"];}
- (NSDate *)endTime     {return [fieldDict objectForKey:@"EndTime"];}
- (NSDate *)firstTime   {return [fieldDict objectForKey:@"StartTime"];}
- (NSDate *)lastTime    {return [fieldDict objectForKey:@"EndTime"];}

- (void)setStartTime:(id)o   { [self setObject:o forKey:@"StartTime"]; }
- (void)setEndTime:(id)o     { [self setObject:o forKey:@"EndTime"]; }

- (id)node { return [(A0bThread*)[self thread] nodeId]; }
- (id)service { return [(A0bThread*)[self thread] serviceId]; }


- (NSString *)entityType
{
    return PajeState;
}
+ (NSString *)entityType
{
    return PajeState;
}
+ (PajeDrawingType)drawingType { return PajeStateDrawingType; }
- (PajeDrawingType)drawingType { return PajeStateDrawingType; }
@end