// EventNames.h
//
// declaration of event names.
// include this file with the following symbol #defined:
//     nothing - declaration of variables as extern
//     DEFINE_STRINGS - declaration of variables not extern
//     INIT_STRINGS - initialization of variables


#if defined(INIT_STRINGS)
#  define CONSTANT_STRING(str, init) str = [UniqueString stringWithString:init]
#else
#  if defined(DEFINE_STRINGS)
#    define CONSTANT_STRING(str, init) NSString *str
#  else // declare strings
#    define CONSTANT_STRING(str, init) extern NSString *str
#  endif
#endif

CONSTANT_STRING(A0_AllocTraceBufferEventName, @"a0_perf_InitUserThreadTraceBuffer");
CONSTANT_STRING(A0_IdentifyFileEventName, @"a0_perf_IdentifyFile");
CONSTANT_STRING(A0InitEventName, @"a0Init");
CONSTANT_STRING(A0NewSlaveEventName, @"a0NewSlave");
CONSTANT_STRING(A0JoinSlaveEventName, @"a0JoinSlave");
CONSTANT_STRING(A0DetachSlaveEventName, @"a0DetachSlave");
CONSTANT_STRING(A0StartRemoteThreadEventName, @"a0StartRemoteThread");
CONSTANT_STRING(A0IStartRemoteThreadEventName, @"a0IStartRemoteThread");
CONSTANT_STRING(A0_BeginThreadServiceEventName, @"a0_perf_BeginThreadService");
CONSTANT_STRING(A0ExitThreadEventName, @"a0ExitThread");
CONSTANT_STRING(A0StartRemoteUrgentEventName, @"a0StartRemoteUrgent");
CONSTANT_STRING(A0IStartRemoteUrgentEventName, @"a0IStartRemoteUrgent");
CONSTANT_STRING(A0_EndUserThreadEventName, @"a0_perf_EndOfUserThread");
CONSTANT_STRING(A0_BeginUrgentServiceEventName, @"a0_perf_BeginUrgentService");
CONSTANT_STRING(A0_EndUrgentServiceEventName, @"a0_perf_EndUrgentService");
CONSTANT_STRING(A0TerminateEventName, @"a0Terminate");
CONSTANT_STRING(A0_UnblockEventName, @"Paje_Macro_Wakeup");
CONSTANT_STRING(A0SendEventName, @"a0Send");
CONSTANT_STRING(A0ISendEventName, @"a0ISend");
CONSTANT_STRING(A0SendBufferEventName, @"a0SendBuffer");
CONSTANT_STRING(A0ISendBufferEventName, @"a0ISendBuffer");
CONSTANT_STRING(A0FSendEventName, @"a0FSend");
CONSTANT_STRING(A0IFSendEventName, @"a0IFSend");
CONSTANT_STRING(A0_SendCompletionEventName, @"a0_perf_CompletedSend");
CONSTANT_STRING(A0ReceiveEventName, @"a0Receive");
CONSTANT_STRING(A0IReceiveEventName, @"a0IReceive");
CONSTANT_STRING(A0ReceiveBufferEventName, @"a0ReceiveBuffer");
CONSTANT_STRING(A0IReceiveBufferEventName, @"a0IReceiveBuffer");
CONSTANT_STRING(A0ReceiveAnyEventName, @"a0ReceiveAny");
CONSTANT_STRING(A0IReceiveAnyEventName, @"a0IReceiveAny");
CONSTANT_STRING(A0ReceiveBufferAnyEventName, @"a0ReceiveBufferAny");
CONSTANT_STRING(A0IReceiveBufferAnyEventName, @"a0IReceiveBufferAny");
CONSTANT_STRING(A0FReceiveEventName, @"a0FReceive");
CONSTANT_STRING(A0IFReceiveEventName, @"a0IFReceive");
CONSTANT_STRING(A0FReceiveAnyEventName, @"a0FReceiveAny");
CONSTANT_STRING(A0IFReceiveAnyEventName, @"a0IFReceiveAny");
CONSTANT_STRING(A0_ReceiveCompletionEventName, @"a0_perf_CompletedRecv");
CONSTANT_STRING(A0WaitRequestEventName, @"a0WaitRequest");
CONSTANT_STRING(A0WaitAnyRequestEventName, @"a0WaitAnyRequest");
CONSTANT_STRING(A0NewPipeEventName, @"a0NewPipe");
CONSTANT_STRING(A0NewSemaphoreEventName, @"a0NewSemaphore");
CONSTANT_STRING(A0PSemaphoreEventName, @"a0PSemaphore");
CONSTANT_STRING(A0TryPSemaphoreEventName, @"a0TryPSemaphore");
CONSTANT_STRING(A0VSemaphoreEventName, @"a0VSemaphore");
CONSTANT_STRING(A0DisposeSemaphoreEventName, @"a0DisposeSemaphore");
CONSTANT_STRING(A0NewMutexEventName, @"a0NewMutex");
CONSTANT_STRING(A0LockMutexEventName, @"a0LockMutex");
CONSTANT_STRING(A0UnlockMutexEventName, @"a0UnlockMutex");
CONSTANT_STRING(A0DisposeMutexEventName, @"a0DisposeMutex");
CONSTANT_STRING(A0NewConditionEventName, @"a0NewCondition");
CONSTANT_STRING(A0SignalConditionEventName, @"a0SignalCondition");
CONSTANT_STRING(A0BroadcastConditionEventName, @"a0BroadcastCondition");
CONSTANT_STRING(A0WaitConditionEventName, @"a0WaitCondition");
CONSTANT_STRING(A0TimedWaitConditionEventName, @"a0TimedWaitCondition");
CONSTANT_STRING(A0DisposeConditionEventName, @"a0DisposeCondition");
CONSTANT_STRING(A0UserEventEventName, @"a0UserEvent");

#if 0
// User events -- redefine when tracer rewritten
CONSTANT_STRING(A0DefineUserContainerType, @"a0DUCT");
CONSTANT_STRING(A0DefineUserEventType, @"a0DUET");
CONSTANT_STRING(A0DefineUserStateType, @"a0DUST");
CONSTANT_STRING(A0DefineUserVariableType, @"a0DUVT");
CONSTANT_STRING(A0DefineUserLinkType, @"a0DULT");
CONSTANT_STRING(A0DefineUserEntityValue, @"a0DUEV");
CONSTANT_STRING(A0CreateUserContainer, @"a0CUC");
CONSTANT_STRING(A0DestroyUserContainer, @"a0DUC");
CONSTANT_STRING(A0NewUserEvent, @"a0NUE");
CONSTANT_STRING(A0SetUserState, @"a0SUS");
CONSTANT_STRING(A0PushUserState, @"a0PuUS");
CONSTANT_STRING(A0PopUserState, @"a0PoUS");
CONSTANT_STRING(A0SetUserVariable, @"a0SUV");
CONSTANT_STRING(A0AddUserVariable, @"a0Add");
CONSTANT_STRING(A0SubUserVariable, @"a0Sub");
CONSTANT_STRING(A0StartUserLink, @"a0SUL");
CONSTANT_STRING(A0EndUserLink, @"a0EUL");
#else
CONSTANT_STRING(A0DefineUserContainerType, @"PajeDefineContainerType");
CONSTANT_STRING(A0DefineUserEventType, @"PajeDefineEventType");
CONSTANT_STRING(A0DefineUserStateType, @"PajeDefineStateType");
CONSTANT_STRING(A0DefineUserVariableType, @"PajeDefineVariableType");
CONSTANT_STRING(A0DefineUserLinkType, @"PajeDefineLinkType");
CONSTANT_STRING(A0DefineUserEntityValue, @"PajeDefineEntityValue");
CONSTANT_STRING(A0CreateUserContainer, @"PajeCreateContainer");
CONSTANT_STRING(A0DestroyUserContainer, @"PajeDestroyContainer");
CONSTANT_STRING(A0NewUserEvent, @"PajeNewEvent");
CONSTANT_STRING(A0SetUserState, @"PajeSetState");
CONSTANT_STRING(A0PushUserState, @"PajePushState");
CONSTANT_STRING(A0PopUserState, @"PajePopState");
CONSTANT_STRING(A0SetUserVariable, @"PajeSetVariable");
CONSTANT_STRING(A0AddUserVariable, @"PajeAddVariable");
CONSTANT_STRING(A0SubUserVariable, @"PajeSubVariable");
CONSTANT_STRING(A0StartUserLink, @"PajeStartLink");
CONSTANT_STRING(A0EndUserLink, @"PajeEndLink");
#endif
#undef CONSTANT_STRING
