//
// UserEvent
//
// holds a user-definable link
//

#import "UserState.h"

@interface UserLink : UserState
{
    id key;
    PajeContainer *sourceContainer;
    PajeContainer *destContainer;
    int startLogicalTime;
    int endLogicalTime;
}

+ (UserLink *)linkOfType:(PajeEntityType *)type
                   value:(id)v
                     key:(id)k
               container:(PajeContainer *)c
         sourceContainer:(PajeContainer *)sc
             sourceEvent:(A0Event *)e;
+ (UserLink *)linkOfType:(PajeEntityType *)type
                   value:(id)v
                     key:(id)k
               container:(PajeContainer *)c
           destContainer:(PajeContainer *)dc
               destEvent:(A0Event *)e;
- (id)initWithType:(PajeEntityType *)type
             value:(id)v
               key:(id)k
         container:(PajeContainer *)c
   sourceContainer:(PajeContainer *)sc
       sourceEvent:(A0Event *)e;
- (id)initWithType:(PajeEntityType *)type
             value:(id)v
               key:(id)k
         container:(PajeContainer *)c
     destContainer:(PajeContainer *)dc
         destEvent:(A0Event *)e;
- (void)dealloc;

- (void)setSourceContainer:(PajeContainer *)sc
               sourceEvent:(A0Event *)e;
- (void)setDestContainer:(PajeContainer *)dc
               destEvent:(A0Event *)e;

- (BOOL)canBeEndedWithValue:(id)v key:(id)k;
- (BOOL)canBeStartedWithValue:(id)v key:(id)k;

- (PajeContainer *)sourceContainer;
- (PajeContainer *)destContainer;

- (void)setStartLogicalTime:(int)t;
- (void)setEndLogicalTime:(int)t;
- (int)startLogicalTime;
- (int)endLogicalTime;
@end

@interface UserLinkInspector : UserStateInspector
@end
