#import "UserState.h"
#import "../General.bproj/Macros.h"

@implementation UserState

+ (UserState *)stateOfType:(PajeEntityType *)type
                     value:(id)v
                 container:(PajeContainer *)c
                startEvent:(A0Event *)e
{
    return [[[self alloc] initWithType:type
                                 value:v
                             container:c
                            startEvent:e] autorelease];
}

- (id)initWithType:(PajeEntityType *)type
             value:(id)v
         container:(PajeContainer *)c
        startEvent:(A0Event *)e
{
    self = [super initWithType:type
                          name:v
                     container:c
                         event:e];
    if (self != nil) {
        imbricationLevel = 0;
    }
    return self;
}
- (void)dealloc
{
    Assign(endEvent, nil);
    [super dealloc];
}

- (id)value
{
    return [super name];
}

- (void)setEndEvent:(A0Event *)e
{
    Assign(endEvent, e);
}

- (NSDate *)endTime
{
    return [endEvent time];
}

- (void)setImbricationLevel:(int)level
{
    imbricationLevel = level;
}

- (int)imbricationLevel
{
    return imbricationLevel;
}

- (NSArray *)fieldNames
{
    NSArray *localFields;
    localFields = [NSArray arrayWithObject:@"Imbrication Level"];
    localFields = [localFields arrayByAddingObjectsFromArray:[endEvent fieldNames]];
    return [[super fieldNames] arrayByAddingObjectsFromArray:localFields];
}

- (id)valueOfFieldNamed:(NSString *)fieldName
{
    id value;
    if ([fieldName isEqual:@"Imbrication Level"])
        return [NSNumber numberWithInt:[self imbricationLevel]];
    value = [super valueOfFieldNamed:fieldName];
    if (value != nil)
        return value;
    value = [endEvent valueOfFieldNamed:fieldName];
    return value;
}

@end

@implementation UserStateInspector
- (void)addLocalFields
{
    [super addLocalFields];
}
@end
