// BusyEnumerator
//
// Enumerator that first enumerates the states of a trace, and
// creates a list of time slices when the node is busy; then,
// enumerates these busy states.

// 19980227 BS  creation

#import <Foundation/Foundation.h>
#import "BusyArray.h"
#import "BusyDate.h"

@interface BusyEnumerator : NSEnumerator
{
    NSEnumerator *enumerator;
    BusyArray *array;
    NSSet *busyEntities;
    BOOL firstFase;
}

- (id)initWithEnumerator:(NSEnumerator *)original
               container:(PajeContainer *)cont
                fromTime:(NSDate *)start
                  toTime:(NSDate *)end
         concurrentTypes:(NSSet *)busySet;
- (void)dealloc;

- (id)nextObject;
@end