// BusyEnumerator.m

// 19980227 BS  creation


#import "BusyEnumerator.h"
#import "ReduceEntity.h"
#import "BusyState.h"

@implementation BusyEnumerator

- (id)initWithEnumerator:(NSEnumerator *)original
               container:(PajeContainer *)cont
                fromTime:(NSDate *)start
                  toTime:(NSDate *)end
         concurrentTypes:(NSSet *)busySet
{
    self = [super init];
    enumerator = [original retain];
    busyEntities = [busySet retain];
    array = [[BusyArray alloc] initWithEntityType:[BusyState entityType] container:cont startTime:start endTime:end];
    firstFase = YES;
    return self;
}

- (void)dealloc
{
    [enumerator release];
    [busyEntities release];
    [array release];
    [super dealloc];
}

- (id)nextObject
{
    id obj;
    if (firstFase) {
        do {
            obj = [enumerator nextObject];
            if ((nil != obj) && [busyEntities containsObject:[obj name]])
                [array addObject:obj];
        } while (obj);
        
        if (/*sendOriginal && */(nil != obj)) {
            return obj;
        } else {
            firstFase = NO;
            [enumerator release];
            enumerator = [[array objectEnumeratorOfClass:[CountReduceEntity class]] retain];
        }
    }
    // second fase -- take objects from the array enumerator
    return [enumerator nextObject];
}

@end
