// BusyState
//
// Has a state of a node
// (start and end time, and active states in this time slice).

// 19980302 BS  creation

#import <Foundation/Foundation.h>
#import "../General.bproj/Protocols.h"

#import "../A0bSimul.bproj/A0State.h"

extern NSString *BusyStateEntityType;

@interface BusyState : /*NSObject <PajeState>*/A0State
{
    NSDate *startTime;
    NSDate *endTime;
    id container;
//    NSArray *relatedEntities;
}

+ (BusyState *)stateWithStartTime:(NSDate *)start
                          endTime:(NSDate *)end
                        container:(PajeContainer *)cont
                  relatedEntities:(NSArray *)related;
- (id)initWithStartTime:(NSDate *)start
                endTime:(NSDate *)end
              container:(PajeContainer *)cont
        relatedEntities:(NSArray *)related;
- (void)dealloc;

+ (PajeDrawingType)drawingType;
+ (NSString *)entityType;

- (PajeDrawingType)drawingType;
- (NSString *)entityType;

- (NSNumber *)value;

- (NSDate *)startTime;
- (NSDate *)endTime;
- (id)container;
- (NSString *)name;
- (NSColor *)color;
- (NSArray *)relatedEntities;
- (void)inspect;
@end
