#import "ColoredButtonCell.h"

@implementation ColoredButtonCell : NSButtonCell
- (void)setColor:(NSColor *)color
{
    [color retain];
    [c release];
    c = color;
}
- (NSColor *)color
{
    return c;
}
- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView
{
    NSRect r = cellFrame;
    [super drawInteriorWithFrame:cellFrame inView:controlView];
    if (c) {
        r.origin.x += NSWidth(r) - NSHeight(r);
        r.size.width = NSHeight(r);
        [c drawSwatchInRect:r];
    }
}
@end
