// EntityDescriptor
//
// holds a small description of an entityType
//

#import <Foundation/Foundation.h>

#import "Protocols.h"
#import "Macros.h"


@interface EntityDescriptor : NSObject
{
    NSString *entityType;
    PajeDrawingType drawingType;
}

//
// Initialisation
//
+ (EntityDescriptor *)descriptorWithEntityType:(NSString *)type
                                   drawingType:(PajeDrawingType)drawType;
- (id)initWithEntityType:(NSString *)type
             drawingType:(PajeDrawingType)drawType;
- (void)dealloc;

//
// Accessors
//
- (NSString *)entityType;
- (PajeDrawingType)drawingType;

- (NSArray *)allNames;
@end
