/* FilteredEnumerator.m created by benhur on Sat 14-Jun-1997 */

#import "FilteredEnumerator.h"

@implementation FilteredEnumerator

- (id)initWithEnumerator:(NSEnumerator *)anEnum filter:(NSSet *)aSet
{
    self = [super init];
    if (self) {
        originalEnumerator = [anEnum retain];
        filter = [aSet retain];
    }
    return self;
}

- (id)initWithEnumerator:(NSEnumerator *)anEnum filter:(NSSet *)aSet selector:(SEL)sel
{
    self = [super init];
    if (self) {
        originalEnumerator = [anEnum retain];
        filter = [aSet retain];
        selector = sel;
    }
    return self;
}

- (void)dealloc
{
    [originalEnumerator release];
    [filter release];
    [super dealloc];
}

- (id)nextObject
{
    id obj;
    if (selector)
        while ((obj = [originalEnumerator nextObject])
               && (nil != [filter member:[obj performSelector:selector]]))
            ;
    else
        while ((obj = [originalEnumerator nextObject])
               && (nil != [filter member:obj]))
            ;
    return obj;
}
@end
