/*
 * GNUstep+Additions
 *
 * Some missing methods in GNUstep
 */

#ifdef GNUSTEP

#import <AppKit/AppKit.h>

@implementation NSRulerView (patch)
/* it is releasing _scrollView and should not */
- (void) dealloc
{
  RELEASE(_unit);
  RELEASE(_clientView);
  RELEASE(_accessoryView);
  RELEASE(_markers);
  RELEASE(_labelFormat);
  [super dealloc];
}
@end

@implementation NSWindow (patch)
NSCachedImageRep *storedImage = nil;
NSRect storedRect;

- (void) cacheImageInRect: (NSRect)aRect
{
  NSView *cacheView;

  storedRect = aRect;
  if (storedImage) [storedImage release];
  storedImage = [[NSCachedImageRep alloc] initWithWindow: nil  rect: NSMakeRect(0, 0, NSWidth(storedRect), NSHeight(storedRect))];
  cacheView = [[storedImage window] contentView];
  [cacheView lockFocus];
  NSCopyBits([self gState], aRect, NSZeroPoint);
  [cacheView unlockFocus];
}

- (void) restoreCachedImage
{
  [[self contentView] lockFocus];
  NSCopyBits([[storedImage window] gState],
	NSMakeRect(0, 0, NSWidth(storedRect), NSHeight(storedRect)),
	storedRect.origin);
  [[self contentView] unlockFocus];
}


@end

@implementation NSClipView (Additions)
- (void) viewFrameChanged: (NSNotification*)aNotification
{
  NSRect proposedVisibleRect;
  NSRect newVisibleRect;
  NSRect newBounds;

  // give documentView a chance to adjust its visible rectangle
  proposedVisibleRect = [self convertRect: _bounds toView: _documentView];
  newVisibleRect = [_documentView adjustScroll: proposedVisibleRect];
  newBounds = [self convertRect: newVisibleRect fromView: _documentView];
  newBounds.origin = [self constrainScrollPoint: newBounds.origin];
  [self setBounds:newBounds];

  /* If document frame does not completely cover _bounds */
  if (NSContainsRect([_documentView frame], _bounds) == NO)
    {
      /*
       * fill the area not covered by documentView with background color
       */
      [self setNeedsDisplay: YES];
    }

  [_super_view reflectScrolledClipView: self];
}

@end
#endif
