#import "MiscTree+Additions.h"

@implementation MiscTree(PajeAdditions)

- (void)setEntityType:(PajeEntityType *)entityType
{
    [self setUserInfo:entityType];
}

- (PajeEntityType *)entityType
{
    return [self userInfo];
}

- (MiscTree *)subtreeWithEntityType:(PajeEntityType *)entityType
{
    NSEnumerator *allEnum;
    MiscTree *subtree;
    if ([[self userInfo] isEqual:entityType])
        return self;
    allEnum = [self preorderAllSubtreeEnumerator];
    while (subtree = [allEnum nextObject]) {
        if ([[subtree userInfo] isEqual:entityType])
            return subtree;
    }
    return nil;
}

- (NSString *)descriptionWithLocale:(NSDictionary *)locale
                             indent:(unsigned int)level
{
    NSMutableDictionary *newDictionary = [NSMutableDictionary dictionary];
    if ([self userInfo])
        [newDictionary setObject:[self userInfo] forKey:@"Entity Type"];
    [newDictionary setObject:[self subtrees] forKey:@"Subtrees"];
    return [newDictionary descriptionWithLocale:locale indent:level];
}

// it doesn't copy the userInfo in the original MiscKit!
- (id)copyWithZone:(NSZone *)zone {
    MiscTree *newTree = [[isa allocWithZone:zone] init];
    NSEnumerator *enumerator = [self subtreeEnumerator];
    id obj;
    NSAssert(nil != newTree, @"could not create new tree");
    while ((obj = [enumerator nextObject])) {
        id newSubtree = [obj copyWithZone:zone];
        NSAssert(nil != newSubtree, @"could not copy subtree");
        [newTree addSubtree:newSubtree];
    }
    [newTree setUserInfo:[self userInfo]];
    return newTree;
}
@end
