
#import "MultiEnumerator.h"

#ifdef GNUSTEP
@implementation NSEnumerator (Additions)
- (NSArray *)allObjects
{
    NSMutableArray *a = [NSMutableArray array];
    id obj;

    while (obj = [self nextObject])
        [a addObject:obj];

    return a;
}
@end
#endif

@implementation MultiEnumerator


+ (MultiEnumerator *)enumeratorWithEnumeratorArray:(NSArray *)array
{
    return [[[self alloc] initWithEnumeratorArray:array] autorelease];
}

+ (MultiEnumerator *)enumerator
{
    return [[[self alloc] initWithEnumeratorArray:[NSMutableArray array]] autorelease];
}

- (id)initWithEnumeratorArray:(NSArray *)array;
{
    [super init];
    origEnums = [array mutableCopy];
    return self;
}

- (void)dealloc
{
    [origEnums release];
    [super dealloc];
}

- (void)addEnumerator:(NSEnumerator *)enumerator
{
    if (enumerator)
        [origEnums addObject:enumerator];
    else
        NSLog(@"nil enumerator ignored");
}

- (id)nextObject;
{
    id obj = nil;

    while (obj == nil) {

        if ([origEnums count] == 0)
            return nil;

        obj = [[origEnums objectAtIndex:0] nextObject];
        if (obj)
            return obj;

        [origEnums removeObjectAtIndex:0];

    }
    return nil; // shuts up compiler
}
@end
