/* PTime.m
 *
 * see PTime.h
 */

/* 19980213 BS  creation
 */

#import "PTime.h"

PTime *initialTime;

@implementation PTime

+ (void)setInitialTime:(PTime *)time
{
    [initialTime release];
    initialTime = [time retain];
}

// there's a bug in NSDate, it's classForCoder and classForArchiver return NSDate
- (Class)classForCoder
{
    return [self class];
}
- (Class)classForArchiver
{
    return [self class];
}

- (id)initWithTimeIntervalSinceReferenceDate:(NSTimeInterval)seconds
{
#ifndef GNUSTEP
    self = [super init];
#endif
    secondsSinceReferenceDate = seconds;
    return self;
}

- (NSTimeInterval)timeIntervalSinceReferenceDate
{
    return secondsSinceReferenceDate;
}

- (NSString *)description
{
    return [NSString stringWithFormat:@"%.6f", initialTime ? [self timeIntervalSinceDate:initialTime] : [self timeIntervalSinceReferenceDate]];
}
- (NSString *)stringValue
{
    return [self description];
}

- (id)copyWithZone:(NSZone *)zone
{
    return [self retain];
}

// NSCoding Protocol
- (void)encodeWithCoder:(NSCoder *)coder
{
    [super encodeWithCoder:coder];
    [coder encodeValueOfObjCType:@encode(NSTimeInterval) at:&secondsSinceReferenceDate];
}

- (id)initWithCoder:(NSCoder *)coder
{
    self = [super initWithCoder:coder];
    [coder decodeValueOfObjCType:@encode(NSTimeInterval) at:&secondsSinceReferenceDate];
    return self;
}
@end
