//
// PajeContainer
//
// superclass for containers
//

#import "PajeContainer.h"
#import "Macros.h"
#import "UniqueString.h"
#import "PTime.h"

@implementation PajeContainer

+ (PajeContainer *)containerWithType:(id)type
                                name:(NSString *)n
                           container:(PajeContainer *)c
{
    return [[[self alloc] initWithType:type
                                  name:n
                             container:c] autorelease];
}

- (id)initWithType:(PajeEntityType *)type
              name:(id)n
         container:(PajeContainer *)c
{
    self = [super initWithType:type
                          name:n
                     container:c];
    if (self) {
        Assign(subContainers, [NSMutableArray array]);
    }
    return self;
}

- (void)dealloc
{
    Assign(subContainers, nil);
    [super dealloc];
}

- (void)addSubContainer:(PajeContainer *)subcontainer
{
    [subContainers addObject:subcontainer];
}

- (BOOL)isContainer
{
    return YES;
}

- (NSDate *)time
{
    return [PTime dateWithTimeIntervalSinceReferenceDate:0.0];
}

- (NSDate *)endTime
{
    return [PTime dateWithTimeIntervalSinceReferenceDate:200.0];
}

- (id)copyWithZone:(NSZone *)zone
{
    return [self retain];
}
@end
