#import <AppKit/AppKit.h>
#import "PajeEntity.h"
#import "PajeContainer.h"

@interface PajeEntityInspector : NSObject
{
    id inspectedEntity;
    id inspectionWindow;
    id nameField;
    id colorField;
    id reuseButton;
    id filterButton;
    id fieldBox;
    id relatedEntitiesBox;
    id relatedEntitiesMatrix;
    
    id fileBox;
    id filenameField;
    id lineNumberField;

    NSMutableSet *nonDisplayedFields;

    float top;
    float bottom;
}

- (id)init;
- (void)dealloc;

- (void)addSubview:(NSView *)view atBottom:(BOOL)atBottom;
- (void)addLastSubview:(NSView *)view;
- (NSBox *)boxWithTitle:(NSString *)boxTitle
            fieldTitles:(NSArray *)titles
            fieldValues:(NSArray *)values;
- (NSBox *)boxWithTitle:(NSString *)boxTitle
            fieldTitles:(NSArray *)titles
             fieldNames:(NSArray *)names;
- (void)addLocalFields;

- (BOOL)isReusable;
- (void)setReusable:(BOOL)reuse;

- (void)inspect:(PajeEntity *)anObj;

- (IBAction)showSource:(id)sender;
- (IBAction)filterEntityName:(id)sender;
@end
