/* InsetLimit.h created by benhur on 25-feb-2001 */

#import <AppKit/AppKit.h>
#import "../General.bproj/FilteredEnumerator.h"
#import "../General.bproj/Protocols.h"
#import "../General.bproj/PajeFilter.h"

@interface InsetLimit : PajeFilter
{
    NSMutableDictionary *limits;
    IBOutlet NSView *view;
    IBOutlet NSPopUpButton *entityTypePopUp;
    IBOutlet NSTextField *minField;
    IBOutlet NSTextField *maxField;
}

- (id)init;
- (void)dealloc;

// read and write defaults
- (void)readDefaults;
- (void)registerDefaults;


//
// Handle interface messages
//
- (IBAction)entityTypeSelected:(id)sender;
- (IBAction)valueChanged:(id)sender;
- (IBAction)increaseMinValue:(id)sender;
- (IBAction)increaseMaxValue:(id)sender;
- (IBAction)decreaseMinValue:(id)sender;
- (IBAction)decreaseMaxValue:(id)sender;

//
// interact with interface
//
- (void)calcPopUp;
- (void)synchronizeValues;
- (PajeEntityType *)selectedEntityType;

- (void)viewWillBeSelected:(NSView *)view;


//
// methods to filter
//
- (void)hierarchyChanged;
- (NSEnumerator *)enumeratorOfEntityType:(PajeEntityType *)entityType
                             inContainer:(PajeContainer *)container
                                fromTime:(NSDate *)start
                                  toTime:(NSDate *)end;
- (int)imbricationLevelForEntity:(PajeEntity *)entity;

@end
