//
// ContainerGroup
//
// A group of containers
//

#import <Foundation/Foundation.h>
#import "../General.bproj/PajeContainer.h"

@interface ContainerGroup : NSObject
{
    NSMutableArray *members;
    NSDate *startTime;
    NSDate *endTime;
    id container;
}

+ (ContainerGroup *)groupWithObject:(id)obj;
- (id)initWithObject:(id)obj;

- (NSArray *)members;

- (void)addObject:(id)obj;
- (void)removeObject:(id)obj;
- (unsigned)count;

- (NSEnumerator *)objectEnumerator;

- (NSString *)description;

- (void)setContainer:(PajeContainer *)c;
- (PajeContainer *)container;

@end
