/* NGCombinedEnumerator
 *
 * An enumerator for a Trace that can enumerate many nodes at the same time.
 * The order of the enumeration is the object with the smallest -time of
 * all node enumerations
 * (given by [trace enumeratorOfEntities:inNode:fromTime:toTime:]).
 */

#import <Foundation/Foundation.h>

@interface NGCombinedEnumerator: NSEnumerator
{
    NSMutableArray *enumerators;
    NSMutableArray *currentObjs;
}

+ (NGCombinedEnumerator *)enumerator;
- (id)init;
- (void)addEnumerator:(NSEnumerator *)enumerator;

- (id)nextObject;
@end
