#import "NGCombinedEnumerator.h"
#import "../General.bproj/Protocols.h"

@implementation NGCombinedEnumerator

+ (NGCombinedEnumerator *)enumerator
{
    return [[[self alloc] init] autorelease];
}

- (id)init
{
    [super init];

    enumerators = [[NSMutableArray alloc] init];
    currentObjs = [[NSMutableArray alloc] init];

    return self;
}

- (void)addEnumerator:(NSEnumerator *)enumerator
{
    id obj = [enumerator nextObject];
    if (obj) {
        [enumerators addObject:enumerator];
        [currentObjs addObject:obj];
    }
}


- (id)nextObject
{
    id obj, minObj = nil;
    NSDate *time, *minTime = nil;
    int index, minIndex = 0;

    // find the object with the minimum time
    for (index = [currentObjs count] - 1; index >= 0; index--) {
        obj = [currentObjs objectAtIndex:index];
        time = [obj time];
        if (!minObj || [minTime earlierDate:time] == time) {
            minObj = obj;
            minTime = time;
            minIndex = index;
        }
    }

    // take the next object for the selected list
    if (minObj) {
        obj = [[enumerators objectAtIndex:minIndex] nextObject];
        if (obj) {
            [currentObjs replaceObjectAtIndex:minIndex withObject:obj];
        } else {
            [currentObjs removeObjectAtIndex:minIndex];
            [enumerators removeObjectAtIndex:minIndex];
        }
    }

    return minObj;
}
@end

