#import <AppKit/AppKit.h>
#import "NodeGroup.h"

@interface NGController : NSObject
{
    IBOutlet NSMatrix *matrix;
    IBOutlet NSView *view;
    IBOutlet NSWindow *window;
    IBOutlet NSButton *groupButton;
    IBOutlet NSButton *ungroupButton;
    NodeGroup *filter;
}
- (id)initWithFilter:(NodeGroup *)comp;
- (void)awakeFromNib;

- (void)reflectChanges;
// something has changed, update display.
// message sent by the filter.


- (IBAction)changeSelection:(id)sender;
// user has changed the selected lines in matrix.
// enable buttons accordingly



- (IBAction)group:(id)sender;
// Create a new group with the selected nodes.


- (IBAction)ungroup:(id)sender;
// ungroup selected group(s)

@end
