//
// NodeGroup.h
//
// Paje filter module that groups nodes.
// After this filter, a group of nodes is seen as one node.
//

#import <AppKit/AppKit.h>
#import "../General.bproj/PajeFilter.h"
#import "ContainerGroup.h"

@interface NodeGroup: PajeFilter
{
    NSMutableSet *allGroups;
    NSMutableDictionary *nodeToGroup;
    IBOutlet id          view;              // view in the inspector window
    id controller;
}

// Manipulate groups
- (NSArray *)allGroups;
- (void)mergeGroups:(NSArray *)groups;
- (void)ungroupGroup:(ContainerGroup *)group;

// add nodes from a newly received trace
- (void)hierarchyChanged;

// Implementing the Trace protocol
- (NSEnumerator *)enumeratorOfEntityType:(PajeEntityType *)entityType
                             inContainer:(PajeContainer *)container;
- (NSEnumerator *)enumeratorOfEntityType:(PajeEntityType *)entityType
                             inContainer:(PajeContainer *)container
                                fromTime:(NSDate *)start
                                  toTime:(NSDate *)end;

- (PajeContainer *)containerForEntity:(id<PajeEntity>)entity;
- (PajeContainer *)sourceContainerForEntity:(id<PajeLink>)entity;
- (PajeContainer *)destContainerForEntity:(id<PajeLink>)entity;

@end
