#
#  checks makefile for the GNUstep Base Library
#
#  Copyright (C) 1997 Free Software Foundation, Inc.
#
#  Written by:	Scott Christley <scottc@net-community.com>
#
#  This file is part of the GNUstep Base Library.
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Library General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
#  Library General Public License for more details.
#
#  You should have received a copy of the GNU Library General Public
#  License along with this library; if not, write to the Free
#  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
ADDITIONAL_GUI_LIBS = -lFoundationExt
# Install into the system root by default
GNUSTEP_INSTALLATION_DIR = $(GNUSTEP_SYSTEM_ROOT)

GNUSTEP_MAKEFILES = $(GNUSTEP_SYSTEM_ROOT)/Makefiles

ADDITIONAL_FLAGS += -DGNUSTEP -I../General.bproj -I.. -g

include $(GNUSTEP_MAKEFILES)/common.make

APP_NAME = Paje

Paje_OBJC_FILES = \
PajeController.m PajeCheckPoint.m Paje_main.m \
Comparing.m FilteredEnumerator.m PSortedArray.m TimeList.m\
Trace.m TranslationTable.m PTime.m NSDate+Comparision.m\
HackedMatrix.m NSUserDefaults+Colors.m ColoredButtonCell.m\
NSString+Additions.m NSMatrix+Additions.m \
Encapsulate.m \
DrawView.m \
DrawView+Finding.m \
DrawView+Mouse.m \
DrawView+Positioning.m \
EntityDescriptor.m \
HierarchyDescriptor.m \
EntityTypeInspector.m \
STController.m \
A0bEvent.m \
A0bEventInspector.m \
A0bReader.m \
A0bThreadId.m \
UniqueString.m

Paje_PSWRAP_FILES = \
drawline.psw

Paje_TIFF_FILES = \
Paje.tiff crosscursor.tiff@ traceFilePaje.tiff \
distant.tiff@ near.tiff@ thick.tiff@ thin.tiff@ toselection.tiff@

Paje_MAIN_MODEL_FILE = Paje_GNU.gmodel

-include Makefile.preamble

include $(GNUSTEP_MAKEFILES)/application.make

-include Makefile.postamble
