// Paje
// ----
// NodeDescriptor.h
// holds a description of a node, with information on it's size and on
// what is inside it (threads, semaphores..)

// 18.apr.1998 BS  creation


#import <Foundation/Foundation.h>

@interface NodeDescriptor : NSObject
{
    id node;
    NSRect rect;
    // rect with the size and position of this node representation on the view
    NSMutableDictionary *entityOffsets;
    NSMutableDictionary *entitySlotHeights;
    NSMutableArray *rects;
    NSMutableArray *heights;
    NSMutableArray *entityTypes;
}

- (id)initWithNode:(id)n;
- (void)dealloc;

- (id)node;
- (void)setRect:(NSRect)r;
- (NSRect)rect;

// there should be a class with these things.
- (void)setOffset:(float)offset forEntityType:(id)entityType;
- (float)offsetForEntityType:(id)entityType;
- (void)setSlotHeight:(float)height forEntityType:(id)entityType;
- (float)slotHeightForEntityType:(id)entityType;

- (BOOL)hasEntitiesOfType:(id)entityType;
- (unsigned)count;
- (void)addSubdivision;
- (float)offsetAtIndex:(unsigned)index;
- (void)setRect:(NSRect)r atIndex:(unsigned)index;
- (NSRect)rectAtIndex:(unsigned)index;
- (void)setSlotHeight:(float)height atIndex:(unsigned)index;
- (float)slotHeightAtIndex:(unsigned)index;
- (void)addEntityType:(id)type atIndex:(unsigned)index;
- (NSArray *)entityTypesAtIndex:(unsigned)index;

- (NSString *)description;
@end