/*
 */

#import "DrawView.h"
#import "STController.h"
//#import "TimeRuler.h"
#ifndef xGNUSTEP
#import "ProcRuler.h"
#endif

@implementation STController

- init
{
    [super init];

    if (![NSBundle loadNibNamed:@"SpaceTime" owner:self])
        NSRunAlertPanel(@"SpaceTime", @"Couldn't load interface file",
                        nil, nil, nil);
#ifdef GNUSTEP
    if (![NSBundle loadNibNamed:@"LotsOfColors" owner:self])
        NSRunAlertPanel(@"SpaceTime", @"Couldn't load interface file LotsOfColors",
                        nil, nil, nil);
#endif

    return self;
}

- (void)removeColorWellBordersRecursively: (NSArray *)views
{
    NSEnumerator *e = [views objectEnumerator];
    NSView *v;

    while (v = [e nextObject]) {
        if ([v isKindOfClass:[NSColorWell class]])
            [(NSColorWell *)v setBordered:NO];
        else
            [self removeColorWellBordersRecursively: [v subviews]];
    }
}

- (void)awakeFromNib
{
#ifdef GNUSTEP
    if (colorsWindow)
        [self removeColorWellBordersRecursively:
            [[colorsWindow contentView] subviews]];
    else return;
#endif
    [scrollView setHasHorizontalRuler:YES];
    [scrollView setHasVerticalRuler:YES];
    [scrollView setVerticalRulerView:[[ProcRuler alloc] initWithScrollView:scrollView]];
    [drawView setNodeRuler:[scrollView verticalRulerView]];
    [[scrollView horizontalRulerView] setClientView:drawView];
    [[scrollView horizontalRulerView] setReservedThicknessForMarkers:0.0];
    [[scrollView verticalRulerView] setClientView:drawView];
    [scrollView setRulersVisible:YES];

    // prepare to receive a notification each time the user selects a file
    [[NSNotificationCenter defaultCenter]
            addObserver:self
               selector:@selector(fileSelected:)
                   name:@"PajeFilenameNotification"
                 object:nil];

    // notify that we are a Tool
    [[NSNotificationCenter defaultCenter]
              postNotificationName:@"PajeRegisterToolNotification"
                            object:self
                          userInfo:[NSDictionary dictionaryWithObjectsAndKeys:
                              self, @"Tool",
                              @"Space Time Diagram", @"Name",
                              nil]];

    [window makeKeyAndOrderFront:self];

    [window setFrameAutosaveName:@"SpaceTime"];
}

- (void)setInputComponent:(PajeComponent *)filter
{
    [super setInputComponent:filter];
    [drawView setFilter:(PajeFilter *)filter];
}

- (void)hierarchyChanged
{
    [drawView hierarchyChanged];
}

- (void)dataChangedForEntityType:(PajeEntityType *)entityType
{
    [drawView dataChangedForEntityType:entityType];
}

- (void)colorChangedForEntityType:(PajeEntityType *)entityType
{
    [drawView colorChangedForEntityType:entityType];
}

- (void)fileSelected:(NSNotification *)notification
/* receives PajeFilenameNotification, changes the window title accordingly */
{
    [window setTitleWithRepresentedFilename:[[notification userInfo] objectForKey:@"Filename"]];
}

- (void)activateTool:(id)sender
/* sent by PajeController when the user selects this Tool */
{
    [window makeKeyAndOrderFront:self];
}

- (void)print:(id)sender
{
//    [[NSPrintOperation printOperationWithView:[window contentView]] runOperation]; 
    [window print:sender];
}
@end
