//

typedef enum {
    NO_FILTERING,
    REUSE_SLOTS,
    COLLAPSE_SERVICE,
    COLLAPSE_NODE,
} filterType;  // these must be the same as the choices in filteringModeSelector
               // in the interface file.

#import <AppKit/AppKit.h>
#import <Eve/Eve.h>
#import "Trace.h"
#import "VTNode.h"
#import "VTService.h"

@interface VirtualThread: EveComponent
{
    Trace               *trace;
    NSDate              *lastStartTime;
    NSDate              *lastEndTime;
    NSMutableDictionary *nodes;
    IBOutlet id          view;              // view in the inspector window
    IBOutlet id          nodeSelector;
    IBOutlet id          filteringModeSelector;
    filterType           defaultFilteringMode;
}

- (IBAction)changeSelectedNode:(id)sender;
- (IBAction)changeFilteringMode:(id)sender;
- (int)threadCountForNode:(id)node;
- (int)slotForThread:(id)threadId
             service:(id)service
                node:(id)node;
@end
